// Package common provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.9.1 DO NOT EDIT.
package common

import (
	"bytes"
	"compress/gzip"
	"encoding/base64"
	"fmt"
	"net/url"
	"path"
	"strings"

	"github.com/getkin/kin-openapi/openapi3"
)

// Defines values for Event.
const (
	EventFAILEDRESOURCESALLOCATION Event = "FAILED_RESOURCES_ALLOCATION"

	EventLOSSOFBEARER Event = "LOSS_OF_BEARER"

	EventRECOVERYOFBEARER Event = "RECOVERY_OF_BEARER"

	EventRELEASEOFBEARER Event = "RELEASE_OF_BEARER"

	EventSESSIONTERMINATION Event = "SESSION_TERMINATION"

	EventUSAGEREPORT Event = "USAGE_REPORT"
)

// Defines values for ResultReason.
const (
	ResultReasonOTHERREASON ResultReason = "OTHER_REASON"

	ResultReasonROAMINGNOTALLOWED ResultReason = "ROAMING_NOT_ALLOWED"
)

// AccumulatedUsage defines model for AccumulatedUsage.
type AccumulatedUsage struct {
	// Unsigned integer identifying a volume in units of bytes.
	DownlinkVolume *Volume `json:"downlinkVolume,omitempty"`

	// Unsigned integer identifying a period of time in units of seconds.
	Duration *DurationSec `json:"duration,omitempty"`

	// Unsigned integer identifying a volume in units of bytes.
	TotalVolume *Volume `json:"totalVolume,omitempty"`

	// Unsigned integer identifying a volume in units of bytes.
	UplinkVolume *Volume `json:"uplinkVolume,omitempty"`
}

// Acknowledgement defines model for Acknowledgement.
type Acknowledgement struct {
	// A human-readable explanation specific to this successful acknowledgement
	Details string `json:"details"`
}

// integer indicating a bandwidth in bits per second.
type Bandwidth int

// string identifying a BDT Reference ID as defined in subclause 5.3.3 of 3GPP TS 29.154.
type BdtReferenceId string

// This data type is defined in the same way as the BdtReferenceId data type, but with the nullable property set to true.
type BdtReferenceIdRm string

// string with format "binary" as defined in OpenAPI Specification.
type Binary string

// String with format "byte" as defined in OpenAPI Specification, i.e, base64-encoded characters.
type Bytes string

// ConfigResult defines model for ConfigResult.
type ConfigResult interface{}

// string with format "date-time" as defined in OpenAPI.
type DateTime string

// string with format "date-time" as defined in OpenAPI with "nullable=true" property.
type DateTimeRm string

// string with format "date-time" as defined in OpenAPI with "readOnly=true" property.
type DateTimeRo string

// integer between and including 1 and 7 denoting a weekday. 1 shall indicate Monday, and the subsequent weekdays shall be indicated with the next higher numbers. 7 shall indicate Sunday.
type DayOfWeek int

// Unsigned integer identifying a period of time in units of minutes.
type DurationMin int32

// Unsigned integer identifying a period of time in units of seconds.
type DurationSec int

// Unsigned integer identifying a period of time in units of seconds with "nullable=true" property.
type DurationSecRm int

// Unsigned integer identifying a period of time in units of seconds with "readOnly=true" property.
type DurationSecRo int

// Possible values are - SESSION_TERMINATION: Indicates that Rx session is terminated. - LOSS_OF_BEARER : Indicates a loss of a bearer. - RECOVERY_OF_BEARER: Indicates a recovery of a bearer. - RELEASE_OF_BEARER: Indicates a release of a bearer. - USAGE_REPORT: Indicates the usage report event.  - FAILED_RESOURCES_ALLOCATION: Indicates the resource allocation is failed.
type Event string

// EventReport defines model for EventReport.
type EventReport struct {
	AccumulatedUsage *AccumulatedUsage `json:"accumulatedUsage,omitempty"`

	// Possible values are - SESSION_TERMINATION: Indicates that Rx session is terminated. - LOSS_OF_BEARER : Indicates a loss of a bearer. - RECOVERY_OF_BEARER: Indicates a recovery of a bearer. - RELEASE_OF_BEARER: Indicates a release of a bearer. - USAGE_REPORT: Indicates the usage report event.  - FAILED_RESOURCES_ALLOCATION: Indicates the resource allocation is failed.
	Event Event `json:"event"`

	// Identifies the IP flows that were sent during event subscription
	FlowIds *[]int `json:"flowIds,omitempty"`
}

// string containing a local identifier followed by "@" and a domain identifier. Both the local identifier and the domain identifier shall be encoded as strings that do not contain any "@" characters. See Clauses 4.6.2 and 4.6.3 of 3GPP TS 23.682 for more information.
type ExternalGroupId string

// string containing a local identifier followed by "@" and a domain identifier. Both the local identifier and the domain identifier shall be encoded as strings that do not contain any "@" characters. See Clause 4.6.2 of 3GPP TS 23.682 for more information.
type ExternalId string

// FlowInfo defines model for FlowInfo.
type FlowInfo struct {
	// Indicates the packet filters of the IP flow. Refer to subclause 5.3.8 of 3GPP TS 29.214 for encoding. It shall contain UL and/or DL IP flow description.
	FlowDescriptions *[]string `json:"flowDescriptions,omitempty"`

	// Indicates the IP flow.
	FlowId int `json:"flowId"`
}

// InvalidParam defines model for InvalidParam.
type InvalidParam struct {
	// Attribute's name encoded as a JSON Pointer, or header's name.
	Param string `json:"param"`

	// A human-readable reason, e.g. "must be a positive integer".
	Reason *string `json:"reason,omitempty"`
}

// string identifying a Ipv4 address formatted in the "dotted decimal" notation as defined in IETF RFC 1166.
type Ipv4Addr string

// string identifying a Ipv4 address formatted in the "dotted decimal" notation as defined in IETF RFC 1166, with "readOnly=true" property.
type Ipv4AddrRo string

// string identifying a Ipv6 address formatted according to clause 4 in IETF RFC 5952. The mixed Ipv4 Ipv6 notation according to clause 5 of IETF RFC 5952 shall not be used.
type Ipv6Addr string

// string identifying a Ipv6 address formatted according to clause 4 in IETF RFC 5952, with "readOnly=true" property. The mixed Ipv4 Ipv6 notation according to clause 5 of IETF RFC 5952 shall not be used.
type Ipv6AddrRo string

// string formatted according to IETF RFC 3986 identifying a referenced resource.
type Link string

// String encoding a Mobile Country Code part of the PLMN, comprising 3 digits, as defined in 3GPP TS 38.413.
type Mcc string

// String encoding a Mobile Network Code part of the PLMN, comprising 2 or 3 digits, as defined in 3GPP TS 38.413.
type Mnc string

// string formatted according to subclause 3.3 of 3GPP TS 23.003 that describes an MSISDN.
type Msisdn string

// NotificationData defines model for NotificationData.
type NotificationData struct {
	// Contains the reported event and applicable information
	EventReports []EventReport `json:"eventReports"`

	// string formatted according to IETF RFC 3986 identifying a referenced resource.
	Transaction Link `json:"transaction"`
}

// PlmnId defines model for PlmnId.
type PlmnId struct {
	// String encoding a Mobile Country Code part of the PLMN, comprising 3 digits, as defined in 3GPP TS 38.413.
	Mcc Mcc `json:"mcc"`

	// String encoding a Mobile Network Code part of the PLMN, comprising 2 or 3 digits, as defined in 3GPP TS 38.413.
	Mnc Mnc `json:"mnc"`
}

// Unsigned integer with valid values between 0 and 65535.
type Port int

// Unsigned integer with valid values between 0 and 65535, with "readOnly=true" property.
type PortRo int

// ProblemDetails defines model for ProblemDetails.
type ProblemDetails struct {
	// A machine-readable application error cause specific to this occurrence of the problem. This IE should be present and provide application-related error information, if available.
	Cause *string `json:"cause,omitempty"`

	// A human-readable explanation specific to this occurrence of the problem.
	Detail *string `json:"detail,omitempty"`

	// string providing an URI formatted according to IETF RFC 3986.
	Instance *Uri `json:"instance,omitempty"`

	// Description of invalid parameters, for a request rejected due to invalid parameters.
	InvalidParams *[]InvalidParam `json:"invalidParams,omitempty"`

	// The HTTP status code for this occurrence of the problem.
	Status *int `json:"status,omitempty"`

	// A short, human-readable summary of the problem type. It should not change from occurrence to occurrence of the problem.
	Title *string `json:"title,omitempty"`

	// string providing an URI formatted according to IETF RFC 3986.
	Type *Uri `json:"type,omitempty"`
}

// string chosen by the SCEF to serve as identifier in a resource URI.
type ResourceId string

// Possible values are - ROAMING_NOT_ALLOWED: Identifies the configuration parameters are not allowed by roaming agreement. - OTHER_REASON: Identifies the configuration parameters are not configured due to other reason.
type ResultReason string

// string that identifies an SCS/AS.
type ScsAsId string

// SponsorInformation defines model for SponsorInformation.
type SponsorInformation struct {
	// It indicates Application Service Provider ID.
	AspId string `json:"aspId"`

	// It indicates Sponsor ID.
	SponsorId string `json:"sponsorId"`
}

// TestNotification defines model for TestNotification.
type TestNotification struct {
	// string formatted according to IETF RFC 3986 identifying a referenced resource.
	Subscription Link `json:"subscription"`
}

// String with format partial-time or full-time as defined in subclause 5.6 of IETF RFC 3339. Examples, 20:15:00, 20:15:00-08:00 (for 8 hours behind UTC).
type TimeOfDay string

// TimeWindow defines model for TimeWindow.
type TimeWindow struct {
	// string with format "date-time" as defined in OpenAPI.
	StartTime DateTime `json:"startTime"`

	// string with format "date-time" as defined in OpenAPI.
	StopTime DateTime `json:"stopTime"`
}

// string providing an URI formatted according to IETF RFC 3986.
type Uri string

// UsageThreshold defines model for UsageThreshold.
type UsageThreshold struct {
	// Unsigned integer identifying a volume in units of bytes.
	DownlinkVolume *Volume `json:"downlinkVolume,omitempty"`

	// Unsigned integer identifying a period of time in units of seconds.
	Duration *DurationSec `json:"duration,omitempty"`

	// Unsigned integer identifying a volume in units of bytes.
	TotalVolume *Volume `json:"totalVolume,omitempty"`

	// Unsigned integer identifying a volume in units of bytes.
	UplinkVolume *Volume `json:"uplinkVolume,omitempty"`
}

// UsageThresholdRm defines model for UsageThresholdRm.
type UsageThresholdRm struct {
	// Unsigned integer identifying a volume in units of bytes with "nullable=true" property.
	DownlinkVolume *VolumeRm `json:"downlinkVolume"`

	// Unsigned integer identifying a period of time in units of seconds with "nullable=true" property.
	Duration *DurationSecRm `json:"duration"`

	// Unsigned integer identifying a volume in units of bytes with "nullable=true" property.
	TotalVolume *VolumeRm `json:"totalVolume"`

	// Unsigned integer identifying a volume in units of bytes with "nullable=true" property.
	UplinkVolume *VolumeRm `json:"uplinkVolume"`
}

// Unsigned integer identifying a volume in units of bytes.
type Volume int64

// Unsigned integer identifying a volume in units of bytes with "nullable=true" property.
type VolumeRm int64

// WebsockNotifConfig defines model for WebsockNotifConfig.
type WebsockNotifConfig struct {
	// Set by the SCS/AS to indicate that the Websocket delivery is requested.
	RequestWebsocketUri *bool `json:"requestWebsocketUri,omitempty"`

	// string formatted according to IETF RFC 3986 identifying a referenced resource.
	WebsocketUri *Link `json:"websocketUri,omitempty"`
}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+Ra727jtrJ/lYHuBW6Lqyj+k6S7AS5wvbaz9UESG5bTxUFTBLQ0tthIpEpSdtwi75Kv",
	"5zXyZAckJVu25T/pbk8+9MtuLHE4Pw7n/+gPJ+BJyhkyJZ3LPxyBMuVMovlxVqvp/wLOFDKl/yRpGtOA",
	"KMrZaSr4OMbkf3+VnOl3MogwIfqv/xY4cS6d/zpd7X1q38rTgaXqoCI0ls7z87PrhCgDQVO9q3PpfCIh",
	"CPwtQ6mcZ9c5q9XfAcQdI5mKuKC/Y2hRNN8BxRUXYxqGyCyEs3eAcMsVXPGM5VK4eCcIrSDAVJFxjBbH",
	"x3fA0eZsEtPAamX9PbTyGtlURTDE3zIqcsWsN94ByEBgwFlI9U+4IjQuwLyHlQzIIuYkhBHncE3E1KpI",
	"/T2s5W7YszA4m1oU5+/ivGSWplwoDOEGQ0pgtEitVBrvYThaIjeELYziolRSQzl/l+DSYwoFIzH4KGYo",
	"oCsEFxbOe6iuRkEDhDtGZoTGhX8LcUKy2KBYX/8ZGQoaFLCf3RyJCdetIMiSLCYKwztJpqifpYKnKBS1",
	"AT3kcxZT9vgTj7MED8HPV2k8mSAWwX6KTr7Ox0CTKa5I/FZeWfp2hJqX1vBLh49/ReuhW8Ej4/MYwykm",
	"+Y1uCCO/li0htyDKEsJOBJJQ3wjgUxoTZk4GMsWATmgAioOKqASZBQFKOcliIBssl6ikElQ7hGfXEYXv",
	"vvx5ieCXCvifCAvnNFTRNj7KFE5RAGWh0U82BQLjYj1QBmOqJKQoQBo37Tmuk1BGkyxxLmtLZvk+hluo",
	"hjhBgSzAXrjN0h4AaIhM0cnCsvzUGcGSCnodIBJCnFCGoQYhs3EQk0zi68u51/SawCfQ/DwYvL6M/NeX",
	"xkevfn7mbctoE8ww2YYz0oIPiSKgiYGu8VURgiQJwpwsNCT9e33LFakL40zBnKrILGNZbGwQck1ZgERl",
	"blpkqLEWC5xL/aQKO2VELHYK0HCacJEQBffO2Cy+dzYE10+RtQY98HNVM4pXLamFwgoF9iuZLRTuYvX6",
	"ssbLBepp0RCJF2cnyAIeYghBRAQJFApZiUVnR3Q6RJk7Ls6wP3Euf/5jTeXxyfrfXiidX57d9ZeJpDJk",
	"+sUv7oaxlum2ztslQQQYG6MrrAIlEAYFWaG5FIVWQ33Xd119DKowkYfcTHfJXB80oaxnqepLMRAhyMK8",
	"zI9wAGOBxmrnjQ+0iEsDf3R72vM7t8CyZIwCSBxzfZ5QX+Vbkd8YOAdRC3NrQyTysI8fltduerS1jarc",
	"WocoHFHr2Y+wkJAoPFE02am5lapYMKlyHX+OjV1/v7T//9Pmf+8s/cRRvmEJi38rWK8vOS4dqvosXlTh",
	"Kt7twbXoT74gPu4ONWNUc0QGhGn2QZyFGm3d/P4BQmQ8D0NzxMeQLDyog4xIHC/NEW44C8nCNSTGRWdj",
	"qdNBpgoimZOMcUkVlnwzPimI6DRCkZuG9OCHTS5+prmYgEeebMD7oRT86lXBr8habijblsAdk3RqpZ5H",
	"3bUYmKKgPDQ+hSYaN2RMB18+gYSyTKFxlvZGLddm42A0LqdR3xCQTQak9xb+VSb01QiOsaYywh2WtQMx",
	"/wsR77OzMuIdNldC3J3lSelGLculpDoDmZE40zFMIJyA3/X9Xv/2YdQd3vRuW6Ne//YSestApyKiYPgE",
	"EqXUOSqVoFAklGkL8uAErvu+/9C/evjUbQ27QyjTEoi5NEclMEYiUGiCYbfd/6k7/OeKaJ1Gl/8zFItt",
	"uutuy+/uJouRSNykuvNbn7sPw+6gPxytnwsh05UMCNTlLKAWmgdwAlet3nW38zDs+v27YbvrP7Sur/vt",
	"CsloWskzEWARSXMJTUzXwrtnjusg0/f2s1MhZ8d11qXnuM62dMzDjaM7rlM+mOM6e0CXguXKMRsdGZqj",
	"b5cvpKLa2xe3t6rDZ9fBQgn3Zj9m0bPrTGI+r8y/euvpTG8Aemmul3MUCFK7+TAzMc4wNe5/uUUpm9m2",
	"lD2Zy0b2YY9TlXYUGdxnwbN0T4Gjy39CmXULWlvWMscJj2M+xxDGC7h3/l9HZRYCgZAnhLLSSg8+8Txs",
	"bW1SxL8tolX0KzJuIsHiykUZcmBcFSCBsAJGKTUHHxHapu6Sry9n3oXXMCz1X5slWNO7+NAwaWXChfZ7",
	"Nk7tqjZKafDfQn6F+L5KaFfaaNiEbxuwtpHOSohVdrXmx1ISPKKCCY010KKMyY3Ns5W4rlU36u4PW3V3",
	"o35m8BsxUTb1oKdy4RWiubvWcj7lAjrXBQsogfMqTHZ15oQ85RbbOFB4WJdy6OTFGZ3tQLrhAfL9qlxA",
	"j81ITMMBESTZvoy0eLzRClJK0HGm8H8kMJKsqRaBf/j9WxhwU7u5wAVESEIU+dpKdRDLGutAz8kudAG9",
	"qQf3TpJJpVWbQMolVXSGRS5z73gHG032dJVSSWdnrTAUR7Z89HIgYShQyrxOUauuy70TcvM7xIAmJL53",
	"tL3ZiLtev/S6o6vXl+FV+/WlXr+4qBRVAW1PufQfAefCtyiyeuns4m2Cvqg4CwkCLkztpThYK4ezDczn",
	"H88bHowihIQ+YWjFYvZbnbdim3PtJza2yb2CdppjnYphuOumLt56U19zusM38lce/+BVX1P2uFMQO05b",
	"4tz8+OFiQ16i6F2Gy2y28iJugmBnN7Dw9kDgho9pjNDmGVNiAW0e6ugiVBFTBtc3ty7oVFBQqUmaENIp",
	"VdLdsJRVWGl+8M7qzWpQ7C2gblHNuXg8AlRDe9yvQ2a7Y2+8qlJ8bVakVLVaM882zJ5j24i88Xt+57YS",
	"xS1Xy85rhyiyHZxwVQdUZAltG7OLYief+9ks2+RXdo6lg0opWTm691mqQQ61EZUgTJLgmEmRsZHNMFWm",
	"d9dPXRW7BnHCbPKwLq7EWsHevmhgBlQJO7ySBVs4NQNLXAkrL9cOtCCMCzMpSVHrF022mrm2i/Pz5vla",
	"I8s8OdS70dyPaoEcxf+o2LcP4OFGyMaQdOs2A21qVQlTQoKIMlylTKWBLaAQXICh3R7Z8SDIhJ1a5c4l",
	"n+/quEEl9LogI57FoXb7qUBZmFIq+IyGa5xOBJqaOudYsjAX6ASWY91K07cDwK+dQO4+ThVPyqQiLDjY",
	"L7gT1C5fpc0VzqdUwGjm+WowCSfqOsU1pQYpvugCgdpOdBqWoT7BNsXRw421jP6Qb5KKqExWjRIRfhyN",
	"BmAXgE7v80nLkaIt6bKiKq7UVRlxodzNW5VZkhDbRCttbQaTeU1mlNDUrBFhU4SJ4EkZlOJvvH374Iib",
	"rxqpD/PcY18DIOISmS7wNRK/3b0yIRPFDHWELlXrugBf9ebuhtWjnOHGZOqYbumw37rp3X5+uO2PTIft",
	"S7dzCRs9qsBMK/OucUn5zBZa4GTVqhCcJCZHmQo08zsPTqA/+rE7fBh2W77pOL5x92LByg64ilDkVd96",
	"U7LiOI7rlPlXNg/9QLbknpsyOUppEEkY+G3/tOVX3oOfcia56JUSiO2OpKxsrfXKM9lWyUcXH78MrFcV",
	"0OtU8pY570N75xirt9kI4as93Rx3VSgfoVTl9Gz7zGttzD+T86xtUImBJtifdMjiqDm/zpgpic3UUOfH",
	"kyzOf+z4OAPOvYui9IHhVRuazeZHD7pPJEljlC40apf188tabfXXSe3DZa0G32kv+QEingmdO0SUhXA3",
	"an9feYf6FF8oC/m8QoaKCFUMhfd+XlQMj40/5+nbaDYFv+Ra2qzqArQ73GVENiEwzoFpH3ZkeVcpItOV",
	"H0UCZcTj8O/98da6LOwQcnMK+PXSGSZ/Uj6W8M0SsmRvl5Gmq5LSao83jTtnhmxtzDleVEyqL84OToqX",
	"+L4VhmNGw3sxHp4Vf8Gx5MGj8ev2o6VtW8uz1Xwpqkof4KNaJTo6ctp8Nv8SwcRX/W65CYQYUzM1pbLI",
	"h9c6amPOYyTmc535Buej4sqGguhHxQdQHR5UJL/Nz4MBjHxofPTqjQb8VL/wLrwajD6sOk6QcsqUyYhv",
	"uVDRmGcshNagJx3XyUTsXDqRUunl6el8Pvea0zT1uJieTlR66qcYyFMigojO8LTx8UGioChPLbdTW11M",
	"KmrVTvF5niw3L0weOUNBYsPeu2ev/4JGrVFzTQMG+mJKGP3d2CiJYUCEYjrn+q417H1yoTXq+S60237L",
	"he7I77kw8jvmv1FL/9P+3rtnrTgGQaeR0hdkstZ8Qpxn9s5KWG2eJJyBwTrSWB3XmaGQ9gh1r+7V9Al5",
	"ioykVAvbq3k1x3VSoiJ9F8/P/w4AAP//fbXugX0zAAA=",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %s", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	var res = make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	var resolvePath = PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		var pathToFile = url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
