// Package discoverserviceapi provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.9.1 DO NOT EDIT.
package discoverserviceapi

import (
	externalRef1 "oransc.org/nonrtric/plt/capif/internal/readonly/common29571"
	externalRef2 "oransc.org/nonrtric/plt/capif/internal/readonly/publishserviceapi"
)

// DiscoveredAPIs defines model for DiscoveredAPIs.
type DiscoveredAPIs struct {
	// Description of the service API as published by the service. Each service API description shall include AEF profiles matching the filter criteria.
	ServiceAPIDescriptions *[]externalRef2.ServiceAPIDescription `json:"serviceAPIDescriptions,omitempty"`
}

// GetAllServiceAPIsParams defines parameters for GetAllServiceAPIs.
type GetAllServiceAPIsParams struct {
	// String identifying the API invoker assigned by the CAPIF core function. It also represents the CCF identifier in the CAPIF-6/6e interface.
	ApiInvokerId string `json:"api-invoker-id"`

	// API name, it is set as {apiName} part of the URI structure as defined in subclause 4.4 of 3GPP TS 29.501 [18].
	ApiName *string `json:"api-name,omitempty"`

	// API major version the URI (e.g. v1).
	ApiVersion *string `json:"api-version,omitempty"`

	// Communication type used by the API (e.g. REQUEST_RESPONSE).
	CommType *externalRef2.CommunicationType `json:"comm-type,omitempty"`

	// Protocol used by the API.
	Protocol *externalRef2.Protocol `json:"protocol,omitempty"`

	// AEF identifer.
	AefId *string `json:"aef-id,omitempty"`

	// Data formats used by the API (e.g. serialization protocol JSON used).
	DataFormat *externalRef2.DataFormat `json:"data-format,omitempty"`

	// The service API category to which the service API belongs to.
	ApiCat *string `json:"api-cat,omitempty"`

	// Features supported by the NF consumer for the CAPIF Discover Service API.
	SupportedFeatures *externalRef1.SupportedFeatures `json:"supported-features,omitempty"`

	// Features supported by the discovered service API indicated by api-name parameter. This may only be present if api-name query parameter is present.
	ApiSupportedFeatures *externalRef1.SupportedFeatures `json:"api-supported-features,omitempty"`
}
