// Package securityapi provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.9.1 DO NOT EDIT.
package securityapi

import (
	"bytes"
	"compress/gzip"
	"encoding/base64"
	"fmt"
	"net/http"
	"net/url"
	"path"
	"strings"

	"github.com/deepmap/oapi-codegen/pkg/runtime"
	"github.com/getkin/kin-openapi/openapi3"
	"github.com/labstack/echo/v4"
	externalRef0 "oransc.org/nonrtric/plt/capif/internal/readonly/common"
	externalRef1 "oransc.org/nonrtric/plt/capif/internal/readonly/common29571"
	externalRef2 "oransc.org/nonrtric/plt/capif/internal/readonly/publishserviceapi"
)

// ServerInterface represents all server handlers.
type ServerInterface interface {

	// (POST /securities/{securityId}/token)
	PostSecuritiesSecurityIdToken(ctx echo.Context, securityId string) error

	// (DELETE /trustedInvokers/{apiInvokerId})
	DeleteTrustedInvokersApiInvokerId(ctx echo.Context, apiInvokerId string) error

	// (GET /trustedInvokers/{apiInvokerId})
	GetTrustedInvokersApiInvokerId(ctx echo.Context, apiInvokerId string, params GetTrustedInvokersApiInvokerIdParams) error

	// (PUT /trustedInvokers/{apiInvokerId})
	PutTrustedInvokersApiInvokerId(ctx echo.Context, apiInvokerId string) error

	// (POST /trustedInvokers/{apiInvokerId}/delete)
	PostTrustedInvokersApiInvokerIdDelete(ctx echo.Context, apiInvokerId string) error

	// (POST /trustedInvokers/{apiInvokerId}/update)
	PostTrustedInvokersApiInvokerIdUpdate(ctx echo.Context, apiInvokerId string) error
}

// ServerInterfaceWrapper converts echo contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler ServerInterface
}

// PostSecuritiesSecurityIdToken converts echo context to params.
func (w *ServerInterfaceWrapper) PostSecuritiesSecurityIdToken(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "securityId" -------------
	var securityId string

	err = runtime.BindStyledParameterWithLocation("simple", false, "securityId", runtime.ParamLocationPath, ctx.Param("securityId"), &securityId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter securityId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostSecuritiesSecurityIdToken(ctx, securityId)
	return err
}

// DeleteTrustedInvokersApiInvokerId converts echo context to params.
func (w *ServerInterfaceWrapper) DeleteTrustedInvokersApiInvokerId(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "apiInvokerId" -------------
	var apiInvokerId string

	err = runtime.BindStyledParameterWithLocation("simple", false, "apiInvokerId", runtime.ParamLocationPath, ctx.Param("apiInvokerId"), &apiInvokerId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter apiInvokerId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.DeleteTrustedInvokersApiInvokerId(ctx, apiInvokerId)
	return err
}

// GetTrustedInvokersApiInvokerId converts echo context to params.
func (w *ServerInterfaceWrapper) GetTrustedInvokersApiInvokerId(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "apiInvokerId" -------------
	var apiInvokerId string

	err = runtime.BindStyledParameterWithLocation("simple", false, "apiInvokerId", runtime.ParamLocationPath, ctx.Param("apiInvokerId"), &apiInvokerId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter apiInvokerId: %s", err))
	}

	// Parameter object where we will unmarshal all parameters from the context
	var params GetTrustedInvokersApiInvokerIdParams
	// ------------- Optional query parameter "authenticationInfo" -------------

	err = runtime.BindQueryParameter("form", true, false, "authenticationInfo", ctx.QueryParams(), &params.AuthenticationInfo)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter authenticationInfo: %s", err))
	}

	// ------------- Optional query parameter "authorizationInfo" -------------

	err = runtime.BindQueryParameter("form", true, false, "authorizationInfo", ctx.QueryParams(), &params.AuthorizationInfo)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter authorizationInfo: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetTrustedInvokersApiInvokerId(ctx, apiInvokerId, params)
	return err
}

// PutTrustedInvokersApiInvokerId converts echo context to params.
func (w *ServerInterfaceWrapper) PutTrustedInvokersApiInvokerId(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "apiInvokerId" -------------
	var apiInvokerId string

	err = runtime.BindStyledParameterWithLocation("simple", false, "apiInvokerId", runtime.ParamLocationPath, ctx.Param("apiInvokerId"), &apiInvokerId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter apiInvokerId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PutTrustedInvokersApiInvokerId(ctx, apiInvokerId)
	return err
}

// PostTrustedInvokersApiInvokerIdDelete converts echo context to params.
func (w *ServerInterfaceWrapper) PostTrustedInvokersApiInvokerIdDelete(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "apiInvokerId" -------------
	var apiInvokerId string

	err = runtime.BindStyledParameterWithLocation("simple", false, "apiInvokerId", runtime.ParamLocationPath, ctx.Param("apiInvokerId"), &apiInvokerId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter apiInvokerId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostTrustedInvokersApiInvokerIdDelete(ctx, apiInvokerId)
	return err
}

// PostTrustedInvokersApiInvokerIdUpdate converts echo context to params.
func (w *ServerInterfaceWrapper) PostTrustedInvokersApiInvokerIdUpdate(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "apiInvokerId" -------------
	var apiInvokerId string

	err = runtime.BindStyledParameterWithLocation("simple", false, "apiInvokerId", runtime.ParamLocationPath, ctx.Param("apiInvokerId"), &apiInvokerId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter apiInvokerId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostTrustedInvokersApiInvokerIdUpdate(ctx, apiInvokerId)
	return err
}

// This is a simple interface which specifies echo.Route addition functions which
// are present on both echo.Echo and echo.Group, since we want to allow using
// either of them for path registration
type EchoRouter interface {
	CONNECT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	DELETE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	GET(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	HEAD(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	OPTIONS(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PATCH(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	POST(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PUT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	TRACE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
}

// RegisterHandlers adds each server route to the EchoRouter.
func RegisterHandlers(router EchoRouter, si ServerInterface) {
	RegisterHandlersWithBaseURL(router, si, "")
}

// Registers handlers, and prepends BaseURL to the paths, so that the paths
// can be served under a prefix.
func RegisterHandlersWithBaseURL(router EchoRouter, si ServerInterface, baseURL string) {

	wrapper := ServerInterfaceWrapper{
		Handler: si,
	}

	router.POST(baseURL+"/securities/:securityId/token", wrapper.PostSecuritiesSecurityIdToken)
	router.DELETE(baseURL+"/trustedInvokers/:apiInvokerId", wrapper.DeleteTrustedInvokersApiInvokerId)
	router.GET(baseURL+"/trustedInvokers/:apiInvokerId", wrapper.GetTrustedInvokersApiInvokerId)
	router.PUT(baseURL+"/trustedInvokers/:apiInvokerId", wrapper.PutTrustedInvokersApiInvokerId)
	router.POST(baseURL+"/trustedInvokers/:apiInvokerId/delete", wrapper.PostTrustedInvokersApiInvokerIdDelete)
	router.POST(baseURL+"/trustedInvokers/:apiInvokerId/update", wrapper.PostTrustedInvokersApiInvokerIdUpdate)

}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+xa627bOBZ+FUKzwLSAItlu0yL+5zpu4cFMYkTOdIHZwKCpY5sTiVRJyk428Lv0775G",
	"nmxBUrZ1s53Ek92dHQNFm0iHh+f6nUv14BAeJ5wBU9JpPziSzCDG5scOISDlkN8C6wmhnySCJyAUBfMe",
	"hODmMbA0dtq/OZTNcUTDkYBvKUjluOsnJKLA8g+mApvfU4ZTNeOC/hNyVCmTaZJwoSCjHKn7BHLHJeEJ",
	"ODeuY563HakEZVNn6VqhRiFIImiiKGdawC1UqaA1b5euoxWgAkKtlNVycxUf/w5EaSY5+1zBN81pwkWM",
	"ldN27k4Wi8WJ/vUkFREwwkMIHbdkQKvviIa1MmZvJRABqpYiZ5qcF7JzREAITFEcyVpDWRPuVb9g/o3A",
	"++whk2q8YPN+pDSB/r3gJOenrwHq8jjBRKEABMWRjgkkIBEggSms6RCfIE0o6ZRBiH4KLi+QFQC9yV3f",
	"jTCN5VunLj7uEipAjqgR4W8CJk7bGQats2arNeryOObsHCvs3eM4+sHf5IafJYZ/ngojSgBklxldx+hZ",
	"8c4nwAJEjUdKdi8Yq8CsoEOdH7o4lVA18IBLSccRoDmOUpAIC0An6PLX3tXP/V/6w9F10PnSa6PhDJCA",
	"OSdrg6sZoFWWFh52Bn1E2ZzfgkBUojAFpLh5w+cgIhpThVKJp7A6IEHMKbEHT9D1Re/vg1532DsfXfU6",
	"weXFH3B5yuAuAaJM5GDJmfcPbb6V9UvaOq5TEaI2WQIgqaDqvs9sime4whlcTpz2bw8F11GmQEwwgXNQ",
	"mOr0W7pFCgyTfujcLG/KiGBfVFzXN5k8oSDy2sNdwiVlUzRJGTGUNZJr2+nD1qJa/ir7ToEGCYiwNiDN",
	"KbuF89or2xlvHPdEvhXzFfO0pfO0M+h/Hg3ScUTlbBTYqBp1Bv3tadvfcN1IuNT2h8nKu7+AmvFQVvVY",
	"EaDYUiB9CoSAEI3vK9E44SL3LLvW09VLQfwHqVMUWSsSU9a3/Jtro2Ih8L1BKYhKJ15FihKG1dm2DrBW",
	"NBdcBzlZp9eTciMwgYOoTZF7/bMxfu+zVxu1Ce3XubiaYjmwyvuuwnGn4fV1NiyeI3sumLDMal0WaMZL",
	"iHABO9OerGpA5uRa99lCUak8eZHXBluxrPefsdTKjVXXsZxjz0EqytY+fkEFvhbUyWQGqYYgVTlwytmr",
	"TF0SKWgr5q2rOMrYbDOuJpHAQoSR0mR5VRCWKIQJZQbU9B+Zjkmk7YQ+eh88lN08wZEExAXiMVUaAbma",
	"gVhQCbkQHXMeAWY2WzfVRqtTxo2duZgvUTY6aayLXx0qrJrsz4BVKqCMTacfm09ySFDhs3SdBYwlJ7fG",
	"NV3OJnT6Qnd/rTIqh2zBYO7WcKvG7tJ0hAoEw9E5JzW48O7LYPD4fRg8fm+dea1W6/H7r81T76PXePxu",
	"hTfx9FngGBZc3Brw12fQBRdqNuYpCzWFTqBURE7bmSmVtH1/sVh476ZJ4nEx9Scq8YMEiPSxIDM6B791",
	"NpIgKEjfXuvbylhbZAd9c6sNXrkuVZjhKcTAlIce/4VajVbDtZJdiilmWVHGERpgoRgIid50rvqfXNQZ",
	"9gMXdbtBx0W9YdB30TA4N/8MO/qv7lsPdaIICTqdKYl0dy7mEJpQpirS5rWlZBWRI4ugcxDSStz0Gt47",
	"rRBPgOGEajN7Da+hBySsZsYLfqaINsHD2r/h0l+PDwmXZizSQGN7kNB2uSpYH10nRTjMGukEa1cpENL0",
	"bbuKANYpHdI5DVMc5WHDDKJO2wirww3HBnzXdzn56NSw42Zjdd24dbNGsk88NNhJOFN6DtY1L0miLJD9",
	"+plyPbLvw4fStLos5pCW0jyQCWfSIkGr0dghzu/SYu3zb5eJvb2E0qkhmaQRssTIUKOrbJmwdJ33ryNQ",
	"T4g6gXp68NegbkpyrUjmlK9EKhWEWdGU/kO+gi5twkagoBqs5+b5sHi+U6y/rxewpUL/zJAtBMr7Kixd",
	"cNS1jkJvcr41psiNcXBHNUBPdelcH3+b8/YzKsZaKF+fNSyaB7BoWhbvDmDxzrJ4fwCL94ZF6+zlLFpn",
	"msXpAeY8teY8PcAWp9YWIUxwGqkXs1mdN5k3hZoC8AXUny6h3LIYX2fAkLTd44/69I8uosoIQ7ACubdb",
	"Xa1NcmN9buyu2aE8sVk1Wn9LQdzn1K6uGGqUXfe3r6jtZtfwqsoWtx47db15xZpaHrtqatjQzLFZR1iz",
	"f8nbJgtdNMZSG8LWvdV0NBE83r548o54XcLrxocDWHwwLJoHSNE8Vo2tVSNJDSOCo2iMye2+BcVDlgLe",
	"mIf3P/hbKJf5ieRp/fxzk71mR/akJn5PbyY3vVlet2MLVk7p5gGKNK0izQMUaVpFmqcHsDg9okI9KphE",
	"Ki0SUvXnHMxeA3v2NhpEAFaA8KbbMDffKbOawqyk9D7Mav4nZc9Np1YNs8uaAQ6Nbx+cn/m21bJGUUyZ",
	"7VCvr/qrforBIrpfcUMCJE8FARdhQrgIzZ7f/kepVCIlKhXQRg84oVecq6VPcEInJytL+vPmvhXDc2Jk",
	"+X+F6/8joHx4q3bE9VfB9b3rOX+zm9u+UN5RCOwK7y9WDra1okWlr0AL/bQvOHSV6Az60nNe1NDmIFyY",
	"W8PjSHrsX484l8O5NAnxATh3bY8f296CvtYq2ecipcb3DXhTDwk4YTDlilbosm+J3j4F8hr/pX7YBs0R",
	"TI9g+pdaBriO+aYhgzj73caO8cxxnTkWFI+j7Es1S2nblEws892HbPs+3OE4icAjPHbKmZcdLH1XlP+o",
	"6FTjqvmKYxgg+2mIp2W+Wf47AAD//0sS6S/JLwAA",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %s", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	var res = make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	pathPrefix := path.Dir(pathToFile)

	for rawPath, rawFunc := range externalRef0.PathToRawSpec(path.Join(pathPrefix, "TS29122_CommonData.yaml")) {
		if _, ok := res[rawPath]; ok {
			// it is not possible to compare functions in golang, so always overwrite the old value
		}
		res[rawPath] = rawFunc
	}
	for rawPath, rawFunc := range externalRef2.PathToRawSpec(path.Join(pathPrefix, "TS29222_CAPIF_Publish_Service_API.yaml")) {
		if _, ok := res[rawPath]; ok {
			// it is not possible to compare functions in golang, so always overwrite the old value
		}
		res[rawPath] = rawFunc
	}
	for rawPath, rawFunc := range externalRef1.PathToRawSpec(path.Join(pathPrefix, "TS29571_CommonData.yaml")) {
		if _, ok := res[rawPath]; ok {
			// it is not possible to compare functions in golang, so always overwrite the old value
		}
		res[rawPath] = rawFunc
	}
	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	var resolvePath = PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		var pathToFile = url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
