// Package securityapi provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.9.1 DO NOT EDIT.
package securityapi

import (
	externalRef0 "oransc.org/nonrtric/plt/capif/internal/readonly/common"
	externalRef1 "oransc.org/nonrtric/plt/capif/internal/readonly/common29571"
)

// Defines values for AccessTokenErrError.
const (
	AccessTokenErrErrorInvalidClient AccessTokenErrError = "invalid_client"

	AccessTokenErrErrorInvalidGrant AccessTokenErrError = "invalid_grant"

	AccessTokenErrErrorInvalidRequest AccessTokenErrError = "invalid_request"

	AccessTokenErrErrorInvalidScope AccessTokenErrError = "invalid_scope"

	AccessTokenErrErrorUnauthorizedClient AccessTokenErrError = "unauthorized_client"

	AccessTokenErrErrorUnsupportedGrantType AccessTokenErrError = "unsupported_grant_type"
)

// Defines values for AccessTokenReqGrantType.
const (
	AccessTokenReqGrantTypeClientCredentials AccessTokenReqGrantType = "client_credentials"
)

// Defines values for AccessTokenRspTokenType.
const (
	AccessTokenRspTokenTypeBearer AccessTokenRspTokenType = "Bearer"
)

// Defines values for Cause.
const (
	CauseOVERLIMITUSAGE Cause = "OVERLIMIT_USAGE"

	CauseUNEXPECTEDREASON Cause = "UNEXPECTED_REASON"
)

// AccessTokenErr defines model for AccessTokenErr.
type AccessTokenErr struct {
	Error            AccessTokenErrError `json:"error"`
	ErrorDescription *string             `json:"error_description,omitempty"`
	ErrorUri         *string             `json:"error_uri,omitempty"`
}

// AccessTokenErrError defines model for AccessTokenErr.Error.
type AccessTokenErrError string

// AccessTokenReq defines model for AccessTokenReq.
type AccessTokenReq struct {
	ClientId     string                  `json:"client_id"`
	ClientSecret *string                 `json:"client_secret,omitempty"`
	GrantType    AccessTokenReqGrantType `json:"grant_type"`
	Scope        *string                 `json:"scope,omitempty"`
}

// AccessTokenReqGrantType defines model for AccessTokenReq.GrantType.
type AccessTokenReqGrantType string

// AccessTokenRsp defines model for AccessTokenRsp.
type AccessTokenRsp struct {
	// JWS Compact Serialized representation of JWS signed JSON object (AccessTokenClaims)
	AccessToken string `json:"access_token"`

	// Unsigned integer identifying a period of time in units of seconds.
	ExpiresIn externalRef0.DurationSec `json:"expires_in"`
	Scope     *string                  `json:"scope,omitempty"`
	TokenType AccessTokenRspTokenType  `json:"token_type"`
}

// AccessTokenRspTokenType defines model for AccessTokenRsp.TokenType.
type AccessTokenRspTokenType string

// Possible values are - OVERLIMIT_USAGE: The revocation of the authorization of the API invoker is due to the overlimit usage of the service API - UNEXPECTED_REASON: The revocation of the authorization of the API invoker is due to unexpected reason.
type Cause string

// SecurityInformation defines model for SecurityInformation.
type SecurityInformation interface{}

// SecurityNotification defines model for SecurityNotification.
type SecurityNotification struct {
	// String identifying the AEF.
	AefId *string `json:"aefId,omitempty"`

	// Identifier of the service API
	ApiIds []string `json:"apiIds"`

	// String identifying the API invoker assigned by the CAPIF core function
	ApiInvokerId string `json:"apiInvokerId"`

	// Possible values are - OVERLIMIT_USAGE: The revocation of the authorization of the API invoker is due to the overlimit usage of the service API - UNEXPECTED_REASON: The revocation of the authorization of the API invoker is due to unexpected reason.
	Cause Cause `json:"cause"`
}

// ServiceSecurity defines model for ServiceSecurity.
type ServiceSecurity struct {
	// string providing an URI formatted according to IETF RFC 3986.
	NotificationDestination externalRef0.Uri `json:"notificationDestination"`

	// Set to true by API invoker to request the CAPIF core function to send a test notification as defined in in subclause 7.6. Set to false or omitted otherwise.
	RequestTestNotification *bool                            `json:"requestTestNotification,omitempty"`
	SecurityInfo            []SecurityInformation            `json:"securityInfo"`
	SupportedFeatures       *externalRef1.SupportedFeatures  `json:"supportedFeatures,omitempty"`
	WebsockNotifConfig      *externalRef0.WebsockNotifConfig `json:"websockNotifConfig,omitempty"`
}

// GetTrustedInvokersApiInvokerIdParams defines parameters for GetTrustedInvokersApiInvokerId.
type GetTrustedInvokersApiInvokerIdParams struct {
	// When set to 'true', it indicates the CAPIF core function to send the authentication information of the API invoker. Set to false or omitted otherwise.
	AuthenticationInfo *bool `json:"authenticationInfo,omitempty"`

	// When set to 'true', it indicates the CAPIF core function to send the authorization information of the API invoker. Set to false or omitted otherwise.
	AuthorizationInfo *bool `json:"authorizationInfo,omitempty"`
}

// PutTrustedInvokersApiInvokerIdJSONBody defines parameters for PutTrustedInvokersApiInvokerId.
type PutTrustedInvokersApiInvokerIdJSONBody ServiceSecurity

// PostTrustedInvokersApiInvokerIdDeleteJSONBody defines parameters for PostTrustedInvokersApiInvokerIdDelete.
type PostTrustedInvokersApiInvokerIdDeleteJSONBody SecurityNotification

// PostTrustedInvokersApiInvokerIdUpdateJSONBody defines parameters for PostTrustedInvokersApiInvokerIdUpdate.
type PostTrustedInvokersApiInvokerIdUpdateJSONBody ServiceSecurity

// PutTrustedInvokersApiInvokerIdJSONRequestBody defines body for PutTrustedInvokersApiInvokerId for application/json ContentType.
type PutTrustedInvokersApiInvokerIdJSONRequestBody PutTrustedInvokersApiInvokerIdJSONBody

// PostTrustedInvokersApiInvokerIdDeleteJSONRequestBody defines body for PostTrustedInvokersApiInvokerIdDelete for application/json ContentType.
type PostTrustedInvokersApiInvokerIdDeleteJSONRequestBody PostTrustedInvokersApiInvokerIdDeleteJSONBody

// PostTrustedInvokersApiInvokerIdUpdateJSONRequestBody defines body for PostTrustedInvokersApiInvokerIdUpdate for application/json ContentType.
type PostTrustedInvokersApiInvokerIdUpdateJSONRequestBody PostTrustedInvokersApiInvokerIdUpdateJSONBody
